<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="名称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入名称" />
      </el-form-item>
      <el-form-item label="类型" prop="type">
        <el-select v-model="formData.type" placeholder="请选择类型">
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.SAFE_DEVICE_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="品牌" prop="brand">
        <el-input v-model="formData.brand" placeholder="请输入品牌" />
      </el-form-item>
      <el-form-item label="型号" prop="model">
        <el-input v-model="formData.model" placeholder="请输入型号" />
      </el-form-item>
      <el-form-item label="所属机构" prop="orgId">
        <el-tree-select
              v-model="formData.orgId"
              :data="deptList"
              :props="defaultProps"
              check-strictly
              node-key="id"
              placeholder="请选择所属机构"
            />
      </el-form-item>
      <el-form-item label="接入协议" prop="protocol">
        <el-select v-model="formData.protocol" placeholder="请选择接入协议">
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.SAFE_DEVICE_PROTOCOL)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="SRS地址" prop="ip">
        <el-input v-model="formData.ip" placeholder="请输入SRS地址" />
      </el-form-item>
      <el-form-item label="SRS端口" prop="port">
        <el-input v-model="formData.port" placeholder="请输入SRS端口" />
      </el-form-item>
      <el-form-item label="SRS服务域" prop="domain">
        <el-input v-model="formData.domain" placeholder="请输入SRS服务域" />
      </el-form-item>
      <el-form-item label="用户名" prop="username">
        <el-input v-model="formData.username" placeholder="请输入用户名" />
      </el-form-item>
      <el-form-item label="密码" prop="password">
        <el-input type="password" v-model="formData.password" placeholder="请输入密码" show-password/>
      </el-form-item>
      <el-form-item label="描述" prop="des">
        <el-input v-model="formData.des" type="textarea" placeholder="请输入描述" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getStrDictOptions, DICT_TYPE } from '@/utils/dict'
import { ServerApi, ServerVO } from '@/api/safe/server'
import * as DeptApi from '@/api/system/dept'
import { defaultProps, handleTree } from '@/utils/tree'

/** 安防后端设备 表单 */
defineOptions({ name: 'ServerForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗
const deptList = ref<Tree[]>([]) // 树形结构

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  name: undefined,
  type: undefined,
  brand: undefined,
  model: undefined,
  orgId: undefined,
  protocol: undefined,
  ip: undefined,
  port: undefined,
  domain: undefined,
  username: undefined,
  password: undefined,
  des: undefined,
})
const formRules = reactive({
  name: [{ required: true, message: '名称不能为空', trigger: 'blur' }],
  protocol: [{ required: true, message: '接入协议不能为空', trigger: 'change' }],
  orgId: [{ required: true, message: '所属机构不能为空', trigger: 'change' }],
  ip: [{ required: true, message: 'SRS地址不能为空', trigger: 'blur' }],
  port: [{ required: true, message: 'SRS端口不能为空', trigger: 'blur' }],
  domain: [{ required: true, message: 'SRS服务域不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await ServerApi.getServer(id)
    } finally {
      formLoading.value = false
    }
  }
  // 加载部门树
  deptList.value = handleTree(await DeptApi.getSimpleDeptList())
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as ServerVO
    if (formType.value === 'create') {
      await ServerApi.createServer(data)
      message.success(t('common.createSuccess'))
    } else {
      await ServerApi.updateServer(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    name: undefined,
    type: undefined,
    brand: undefined,
    model: undefined,
    orgId: undefined,
    protocol: undefined,
    ip: undefined,
    port: undefined,
    domain: undefined,
    username: undefined,
    password: undefined,
    des: undefined,
  }
  formRef.value?.resetFields()
}
</script>